﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Reflection;

namespace ImageConverterXExample
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();
        }

        private void bnClose_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void lbAdditional_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            try
            {
                System.Diagnostics.Process.Start("http://www.coolutils.com/CommandLine/TotalImageConverter");
            }
            catch {}

        }

        private void bnOpenDestination_Click(object sender, EventArgs e)
        {
            try
            {
                System.Diagnostics.Process.Start(System.IO.Path.GetDirectoryName(edDestination.Text));
            }
            catch { }

        }

        private void MainForm_Load(object sender, EventArgs e)
        {
            cbFormat.SelectedIndex = 0;
            cbRotate.SelectedIndex = 0;
        }

        private void bnConvert_Click(object sender, EventArgs e)
        {
            Type oType = Type.GetTypeFromProgID("ImageConverter.ImageConverterX");
            if (oType == null)
            {
                MessageBox.Show("ImageConverterX does not installed properly");
                return;
            }


            // We use late bindings to allow build without installed ImageConverterX
            // You should use syntax like:
            //IImageConverterX Conv = (IImageConverterX)Activator.CreateInstance(oType);
            // with ImageConverter reference

            object Conv = Activator.CreateInstance(oType);

            string sSource = edSource.Text;
            string sFormat = cbFormat.SelectedItem.ToString();
            string sConverted = Path.ChangeExtension(edDestination.Text, "." + sFormat);
            string sCmd = "-c " + sFormat;
            switch (cbRotate.SelectedIndex)
            {
                case 1:
                    sCmd += "-o ue ";
                    break;
                case 2:
                    sCmd += "-o rt ";
                    break;
                case 3:
                    sCmd += "-o rb ";
                    break;
            }
            if ((edWidth.Text != "") && (edHeight.Text != ""))
            {
                sCmd += "-s " + edWidth.Text + "x" + edHeight.Text;
                if (cbProportions.Checked)
                {
                    sCmd += " -m t ";
                }
                else
                {
                    sCmd += " -m s ";
                }
            }
            sCmd += edAdditional.Text;
            
            object[] parameters;
            parameters = new object[3];
            parameters[0] = sSource;
            parameters[1] = sConverted;
            parameters[2] = sCmd;

            Conv.GetType().InvokeMember("Convert", BindingFlags.InvokeMethod, null, Conv, parameters);
            /*Conv.Convert(
                sSource,
                sConverted,
                sCmd); */
            MessageBox.Show("Convert compeleted");
         }
    }
}
